##
## Scriptlink interface "helper"
## by Kegetys
##

from ctypes import *
import sys
import time

pipeName = "default"		# Name of pipe to connect to

# Win32 defines
INVALID_HANDLE_VALUE = -1
GENERIC_READ = 0x80000000
GENERIC_WRITE = 0x40000000
OPEN_EXISTING = 0x03

pipe = ""		# Win32 handle to pipe
connected = False

# status return types
DISCONNECTED = 0
NODATA = 1
DATA = 2

def connect(name):
	# Open handle to pipe
	global pipeName, connected, pipe
	pipeName = name
	sys.stdout.write("Connecting to pipe '"+pipeName+"' ")
	while not connected:
		pipe = windll.kernel32.CreateFileA("\\\\.\\pipe\\scriptlink_"+pipeName, GENERIC_READ|GENERIC_WRITE, 0, None, OPEN_EXISTING, 0, None)	
		if pipe != INVALID_HANDLE_VALUE:
			# Successfully connected
			connected = True
		else:
			sys.stdout.write(".")
			time.sleep(1)
	print "connected"


# Receive data from pipe
def receiveData():
	global connected	
	if not connected:
		return DISCONNECTED,""
		
	avail = c_ulong(0) 		# Number of bytes waiting in pipe to be read
	availmsg = c_ulong(0) # Number of bytes in next message (avail > availmsg = more than one message waiting)
	if windll.kernel32.PeekNamedPipe(pipe, None, 0, None, byref(avail), byref(availmsg)) != 1:
		# Disconnected
		connected = False
		return DISCONNECTED,""
	
	if availmsg.value > 0 and avail.value >= availmsg.value:
		# Data in pipe, read it
		buffer = create_string_buffer(availmsg.value)	# Buffer for next message
		read = c_ulong(0)
		windll.kernel32.ReadFile(pipe, buffer, availmsg.value, byref(read), None)
		return DATA,buffer.value
	return NODATA,""

# Disconnect
def close():
	windll.kernel32.CloseHandle(pipe)

