##
## Sample "GPS" application for ArmAlib scriptlink
## by Kegetys
##
## Windows only, pretty crappy code
##

from Tkinter import *
import thread
import scriptlink
import time

# Load map image
root = Tk()
mapImg = PhotoImage(file = 'Intro.gif')

playerpos = [1500, 1500.0]	# Player position
resolution = 3.39	# blaah

wwidth = 400 	# Window width
wheight = 300	# Window height

# Converts a "string" array ("[1,2,3]") to array of floats
def stringToFloatArray(data):
	data = data.lstrip('[').rstrip(']').split(',')	# Strip array delimeters & split
	data = map(lambda x: float(x), data)
	return data
	
class App:
	frame = ""
	canvas = ""
	cx = 0
	cy = 0
	posx = 0
	posy = 0
	rate = 10
	color = False
	master = ""
	def __init__(self, master):
		self.master = master
		frame = Frame(master, border=1)
		frame.grid(row=0, columnspan=4)
		self.canvas = Canvas(width = wwidth, height = wheight, bg = 'white')
		self.canvas.pack(expand = YES, fill = BOTH)
		
		# Canvas center
		self.cx = (wwidth/2)		
		self.cy = (wheight/2)		
		self.master.after(self.rate, self.update)
		
	def update(self):
		# Update "GPS"
		
		# player position
		self.posx = playerpos[0]/resolution
		self.posy = playerpos[1]/resolution		
		
		# ArmA coordinates are relative to the south west corner of the map
		self.canvas.create_image(self.cx-self.posx, self.cy+self.posy, image = mapImg, anchor = SW)
		
		if not scriptlink.connected:
			self.color = not self.color
			self.canvas.create_text(self.cx,self.cy, text="Connecting...", fill=("red" if self.color else "blue"), font=("Helvectica", "16"))
			self.rate = 500
		else:
			# Draw player position in center		
			osi = 5
			self.canvas.create_oval(self.cx-osi,self.cy-osi,self.cx+osi,self.cy+osi, fill="red")
			self.rate = 50
				
		self.master.after(self.rate, self.update)

# Thread which handles armalib pipe read & updates tkinter values
def pipeThread():
	global playerpos
	while(True):
		if not scriptlink.connected:
			# Connect first
			scriptlink.connect("gpspipe")
		else:
			# Connected, receive data
			status,data = scriptlink.receiveData()
			if status == scriptlink.DISCONNECTED:
				print "Disconnected"
				scriptlink.close()
			elif status == scriptlink.NODATA:
				time.sleep(0.01)
			elif status == scriptlink.DATA:
				data = stringToFloatArray(data)
				playerpos = data
	
	
# Connect pipe, then start armalib pipe thread
thread.start_new(pipeThread, ())
				
# create app
app = App(root)
root.title("ArmAlib GPS sample")
root.resizable(width=False, height=False)
root.mainloop()